# mypy-boto3-pinpoint-email<a id="mypy-boto3-pinpoint-email"></a>

[![PyPI - mypy-boto3-pinpoint-email](https://img.shields.io/pypi/v/mypy-boto3-pinpoint-email.svg?color=blue)](https://pypi.org/project/mypy-boto3-pinpoint-email)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-pinpoint-email.svg?color=blue)](https://pypi.org/project/mypy-boto3-pinpoint-email)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-pinpoint-email?color=blue)](https://pypistats.org/packages/mypy-boto3-pinpoint-email)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.PinpointEmail 1.17.70](https://boto3.amazonaws.com/v1/documentation/api/1.17.70/reference/services/pinpoint-email.html#PinpointEmail)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-buider 4.11.1](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-pinpoint-email docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_pinpoint_email/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-pinpoint-email](#mypy-boto3-pinpoint-email)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

## How to install<a id="how-to-install"></a>

Install `boto3-stubs` for `PinpointEmail` service.

```bash
python -m pip install boto3-stubs[pinpoint-email]
```

## Usage<a id="usage"></a>

### VSCode<a id="vscode"></a>

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[pinpoint-email]` in your environment:
  `python -m pip install 'boto3-stubs[pinpoint-email]'`

Both type checking and auto-complete should work for `PinpointEmail` service.
No explicit type annotations required, write your `boto3` code as usual.

### PyCharm<a id="pycharm"></a>

- Install `boto-stubs[pinpoint-email]` in your environment:
  `python -m pip install 'boto3-stubs[pinpoint-email]'`

Both type checking and auto-complete should work for `PinpointEmail` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`boto3-stubs` submodules.

### Other IDEs<a id="other-ides"></a>

Not tested, but as long as your IDE support `mypy` or `pyright`, everything
should work.

### mypy<a id="mypy"></a>

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[pinpoint-email]` in your environment:
  `python -m pip install 'boto3-stubs[pinpoint-email]'`
- Run `mypy` as usual

Type checking should work for `PinpointEmail` service. No explicit type
annotations required, write your `boto3` code as usual.

### pyright<a id="pyright"></a>

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[pinpoint-email]` in your environment:
  `python -m pip install 'boto3-stubs[pinpoint-email]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `PinpointEmail` service. No explicit type
annotations required, write your `boto3` code as usual.

## Explicit type annotations<a id="explicit-type-annotations"></a>

### Client annotations<a id="client-annotations"></a>

`PinpointEmailClient` provides annotations for
`boto3.client("pinpoint-email")`.

```python
import boto3

from mypy_boto3_pinpoint_email import PinpointEmailClient

client: PinpointEmailClient = boto3.client("pinpoint-email")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: PinpointEmailClient = session.client("pinpoint-email")
```

### Paginators annotations<a id="paginators-annotations"></a>

`mypy_boto3_pinpoint_email.paginator` module contains type annotations for all
paginators.

```python
from mypy_boto3_pinpoint_email import PinpointEmailClient
from mypy_boto3_pinpoint_email.paginator import (
    GetDedicatedIpsPaginator,
    ListConfigurationSetsPaginator,
    ListDedicatedIpPoolsPaginator,
    ListDeliverabilityTestReportsPaginator,
    ListEmailIdentitiesPaginator,
)

client: PinpointEmailClient = boto3.client("pinpoint-email")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
get_dedicated_ips_paginator: GetDedicatedIpsPaginator = client.get_paginator("get_dedicated_ips")
list_configuration_sets_paginator: ListConfigurationSetsPaginator = client.get_paginator("list_configuration_sets")
list_dedicated_ip_pools_paginator: ListDedicatedIpPoolsPaginator = client.get_paginator("list_dedicated_ip_pools")
list_deliverability_test_reports_paginator: ListDeliverabilityTestReportsPaginator = client.get_paginator("list_deliverability_test_reports")
list_email_identities_paginator: ListEmailIdentitiesPaginator = client.get_paginator("list_email_identities")
```

### Literals<a id="literals"></a>

`mypy_boto3_pinpoint_email.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from mypy_boto3_pinpoint_email.literals import (
    BehaviorOnMxFailure,
    DeliverabilityDashboardAccountStatus,
    DeliverabilityTestStatus,
    DimensionValueSource,
    DkimStatus,
    EventType,
    GetDedicatedIpsPaginatorName,
    IdentityType,
    ListConfigurationSetsPaginatorName,
    ListDedicatedIpPoolsPaginatorName,
    ListDeliverabilityTestReportsPaginatorName,
    ListEmailIdentitiesPaginatorName,
    MailFromDomainStatus,
    TlsPolicy,
    WarmupStatus,
)

def check_value(value: BehaviorOnMxFailure) -> bool:
    ...
```

### Typed dictionaries<a id="typed-dictionaries"></a>

`mypy_boto3_pinpoint_email.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_pinpoint_email.type_defs import (
    BlacklistEntryTypeDef,
    BodyTypeDef,
    CloudWatchDestinationTypeDef,
    CloudWatchDimensionConfigurationTypeDef,
    ContentTypeDef,
    CreateDeliverabilityTestReportResponseTypeDef,
    CreateEmailIdentityResponseTypeDef,
    DailyVolumeTypeDef,
    DedicatedIpTypeDef,
    DeliverabilityTestReportTypeDef,
    DeliveryOptionsTypeDef,
    DestinationTypeDef,
    DkimAttributesTypeDef,
    DomainDeliverabilityCampaignTypeDef,
    DomainDeliverabilityTrackingOptionTypeDef,
    DomainIspPlacementTypeDef,
    EmailContentTypeDef,
    EventDestinationDefinitionTypeDef,
    EventDestinationTypeDef,
    GetAccountResponseTypeDef,
    GetBlacklistReportsResponseTypeDef,
    GetConfigurationSetEventDestinationsResponseTypeDef,
    GetConfigurationSetResponseTypeDef,
    GetDedicatedIpResponseTypeDef,
    GetDedicatedIpsResponseTypeDef,
    GetDeliverabilityDashboardOptionsResponseTypeDef,
    GetDeliverabilityTestReportResponseTypeDef,
    GetDomainDeliverabilityCampaignResponseTypeDef,
    GetDomainStatisticsReportResponseTypeDef,
    GetEmailIdentityResponseTypeDef,
    IdentityInfoTypeDef,
    InboxPlacementTrackingOptionTypeDef,
    IspPlacementTypeDef,
    KinesisFirehoseDestinationTypeDef,
    ListConfigurationSetsResponseTypeDef,
    ListDedicatedIpPoolsResponseTypeDef,
    ListDeliverabilityTestReportsResponseTypeDef,
    ListDomainDeliverabilityCampaignsResponseTypeDef,
    ListEmailIdentitiesResponseTypeDef,
    ListTagsForResourceResponseTypeDef,
    MailFromAttributesTypeDef,
    MessageTagTypeDef,
    MessageTypeDef,
    OverallVolumeTypeDef,
    PaginatorConfigTypeDef,
    PinpointDestinationTypeDef,
    PlacementStatisticsTypeDef,
    RawMessageTypeDef,
    ReputationOptionsTypeDef,
    SendEmailResponseTypeDef,
    SendQuotaTypeDef,
    SendingOptionsTypeDef,
    SnsDestinationTypeDef,
    TagTypeDef,
    TemplateTypeDef,
    TrackingOptionsTypeDef,
    VolumeStatisticsTypeDef,
)

def get_structure() -> BlacklistEntryTypeDef:
    return {
      ...
    }
```

## Versioning<a id="versioning"></a>

`mypy-boto3-pinpoint-email` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

## Documentation<a id="documentation"></a>

All type annotations can be found in
[mypy-boto3-pinpoint-email docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_pinpoint_email/)

## Support and contributing<a id="support-and-contributing"></a>

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
